## snapd 2.72%2Bubuntu24.04

=== tests/lib/snaps/store/test-snapd-uhid/Makefile ===
CFLAGS += -Wall -Werror
.PHONY: all
all: uhid-test

uhid-test: uhid-test.c
