## snapd 2.72+ubuntu22.04

=== tests/utils/features/requirements.txt ===
dash
dash-bootstrap-components
dash-daq
pymongo
