=== tests/lib/snaps/store/test-snapd-setpriority/Makefile ===
CFLAGS += -Wall -Werror
.PHONY: all
all: setpriority

setpriority: setpriority.c
