=== core-initrd/25.04/debian/changelog ===
ubuntu-core-initramfs (71+2.71+g129.cddf2e3+25.04) plucky; urgency=medium

  * Update to snapd version 2.71+g129.cddf2e3

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 28 Aug 2025 15:57:01 -0400
