=== tests/lib/snaps/store/test-snapd-fuse-consumer/Makefile ===
# -*- Mode: Makefile; indent-tabs-mode:t; tab-width: 4 -*-

all:

install:
	mkdir -p $(DESTDIR)/bin
	cp -a /usr/share/doc/python-fuse/examples/example/hello.py $(DESTDIR)/bin/create
	cp -a /usr/share/doc/python-fuse/examples/example/_find_fuse_parts.py $(DESTDIR)/bin
	chmod a+x $(DESTDIR)/bin/create
