## snapd 2.72+ubuntu26.04.1

=== tests/lib/snaps/store/test-snapd-daemon-user/Makefile ===
all:
	cd ./src && make all

install:
	cd ./src && make install

clean:
	cd ./src && make clean
