=== core-initrd/latest/debian/changelog ===
ubuntu-core-initramfs (72+2.71+g129.cddf2e3+25.10) questing; urgency=medium

  * Update to snapd version 2.71+g129.cddf2e3

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 28 Aug 2025 15:57:24 -0400

ubuntu-core-initramfs (72+2.70+g138.873912a+25.10) questing; urgency=medium

  * Update to snapd version 2.70+g138.873912a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 03 Jul 2025 21:50:50 -0400

ubuntu-core-initramfs (72+2.70+g50.d4bfa73+25.10) questing; urgency=medium

  * Update to snapd version 2.70+g50.d4bfa73

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 12 Jun 2025 10:17:45 -0400

ubuntu-core-initramfs (72+2.69+g139.0b18e2d+25.10) questing; urgency=medium

  * First questing release

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 22 May 2025 09:33:19 -0400
